<?php

namespace RxConnexionBundle\Controller;

use RxConnexionBundle\Entity\MarketingStaffScheduleStatusEntity;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\JsonResponse;

use RxConnexionBundle\Entity\AuditTrailEntity;

use RxConnexionBundle\Form\MarketingStaffScheduleStatusForm;

/**
 * @Route("/main/marketing_staff_appointment_status")
 */
class MarketingStaffScheduleStatusController extends Controller
{
    /**
     * @Route("", name="marketing_staff_schedule_status")
     */
    public function indexAction() {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Marketing Staff Schedule Status'))) return $authService->redirectToHome();

        return $this->render('@RxConnexion/MarketingStaffScheduleStatus/index.html.twig', array(
            'title' => 'Manage Marketing Staff Appointment Status',
            'page_title' => 'Manage Marketing Staff Appointment Status',
            'javascripts' => array('rxconnexion/admin/js/marketingStaffScheduleStatus/marketingStaffScheduleStatus.js?v=1.0.0')
        ));
    }

    /**
     * @Route("/ajax_list", name="marketing_staff_schedule_status_ajax_list")
     */
    public function ajax_list(Request $request) {

        $get = $request->query->all();

        $result = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => 0,
            "recordsFiltered" => 0,
            "data" => array()
        );

        $authService = $this->get('rx_connexion.authService');
        if($authService->isLoggedIn()) {

            $hasUpdate = $authService->isUserHasAccesses(array('Admin Marketing Staff Schedule Status Update'), false);

            $data = $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:MarketingStaffScheduleStatusEntity')->ajax_list($get, $this->get('session')->get('userData'));

            foreach($data['results'] as $row) {

                $id = base64_encode($row['id']);
                $action = '';

                if($hasUpdate) {
                    $url = $this->generateUrl('marketing_staff_schedule_status_form', array(
                        'action' => 'u',
                        'id' => $id
                    ));
                    $action = "<a class='action-button-style' href='$url'>Update</a>";
                }

                $values = array(
                    $row['account_desc'],
                    $row['code'],
                    $row['description'],
                    $row['startDate'],
                    $row['endDate'],
                    $action
                );

                $result['data'][] = $values;
            }

            $result['recordsTotal'] = $data['total'];
            $result['recordsFiltered'] = $data['total'];
        }

        return new JsonResponse($result);
    }

    /**
     * @Route(
     *      "/form/{action}/{id}",
     *      defaults = {
     *          "action":  "n",
     *          "id": 0
     *      },
     *      requirements = {
     *          "action": "n|u"
     *      },
     *      name = "marketing_staff_schedule_status_form"
     * )
     */
    public function formAction($action, $id, Request $request) {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Marketing Staff Schedule Status New', 'Admin Marketing Staff Schedule Status Update'))) return $authService->redirectToHome();

        $em = $this->getDoctrine()->getManager();

        $scheduleStatus = $em->getRepository('RxConnexionBundle:MarketingStaffScheduleStatusEntity')->find(base64_decode($id));
        if(!$scheduleStatus) {
            $scheduleStatus = new MarketingStaffScheduleStatusEntity();
        }

        $formOptions = array('action' => $action);
        $form = $this->createForm(MarketingStaffScheduleStatusForm::class, $scheduleStatus, $formOptions);

        if($request->getMethod() === 'POST') {

            $scheduleStatus_form = $request->get($form->getName());
            $result = $this->processForm($scheduleStatus_form, $scheduleStatus, $form, $request);

            if($result['success']) {
                if($result['redirect'] === 'index') {
                    return $this->redirect($this->generateUrl('marketing_staff_schedule_status'), 302);
                } else if($result['redirect'] === 'form') {
                    return $this->redirect($this->generateUrl('marketing_staff_schedule_status_form', array(
                        'action' => 'u',
                        'id' => base64_encode($result['id'])
                    )), 302);
                } else if($result['redirect'] === 'form with error') {
                    return $this->redirect($this->generateUrl('marketing_staff_schedule_status_form'), 302);
                }
            } else {
                $form->submit($scheduleStatus_form, false);
            }
        }

        $title = ($action === 'n' ? 'New' : 'Update') . ' Marketing Staff Appointment Status';

        return $this->render('@RxConnexion/MarketingStaffScheduleStatus/form.html.twig', array(
            'title' => $title,
            'page_title' => $title,
            'javascripts' => array('rxconnexion/admin/js/marketingStaffScheduleStatus/marketingStaffScheduleStatus_form.js?v=1.0.0'),
            'form' => $form->createView(),
            'action' => $action,
            'id' => $id
        ));
    }

    private function processForm($scheduleStatus_form, $scheduleStatus, $form, Request $request) {

        $em = $this->getDoctrine()->getManager();

        $errors = $em->getRepository('RxConnexionBundle:MarketingStaffScheduleStatusEntity')->validate($scheduleStatus_form);

        if(!count($errors)) {

            switch($scheduleStatus_form['action']) {

                case 'n': // new

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $em->persist($scheduleStatus);
                        $em->flush();

                        $newAT = new AuditTrailEntity(
                            'Marketing Staff Appointment Status',
                            $em->getClassMetadata(MarketingStaffScheduleStatusEntity::class)->getTableName(),
                            AuditTrailEntity::AXN_NEW
                        );
                        $newAT->entity = $scheduleStatus;
                        $newAT->parseDetails();
                        $em->persist($newAT);
                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Saved.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'u': // update

                    $newAT = new AuditTrailEntity(
                        'Marketing Staff Appointment Status',
                        $em->getClassMetadata(MarketingStaffScheduleStatusEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_UPDATE
                    );
                    $newAT->entity = $scheduleStatus;
                    $newAT->parseOriginalDetails();

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $newAT->entity = $scheduleStatus;
                        $newAT->parseDetails();

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Updated.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'd': // delete

                    $newAT = new AuditTrailEntity(
                        'Marketing Staff Appointment Status',
                        $em->getClassMetadata(MarketingStaffScheduleStatusEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_DELETE
                    );
                    $newAT->entity = $scheduleStatus;
                    $newAT->parseDetails();
                    $em->persist($newAT);

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        //$em->remove($scheduleStatus);
                        $scheduleStatus->setIsDeleted(true);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Deleted.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;
            }

            $result['success'] = true;

        } else {

            foreach($errors as $error) {
                $this->get('session')->getFlashBag()->add('error_messages', $error);
            }

            $result['success'] = false;
        }

        return $result;
    }

    /**
     * @Route("/autocomplete", name="marketing_staff_schedule_status_autocomplete")
     */
    public function autocompleteAction(Request $request) {

        $q = $request->get('query');

        $result = array(
            'query' => 'cities',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:MarketingStaffScheduleStatusEntity')->autocomplete_suggestions($q)
        );

        return new JsonResponse($result);
    }

    /**
     * @Route("/schedule_status_for_calendar_autocomplete", name="marketing_staff_schedule_status_for_calendar_autocomplete")
     */
    public function schedule_status_for_calendar_autocompleteAction(Request $request) {

        $chartType_id = $request->get('chartType_id');
        $q = $request->get('query');

        $result = array(
            'query' => 'description',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:MarketingStaffScheduleStatusEntity')->scheduleStatus_autocomplete_suggestions($q, $chartType_id)
        );

        return new JsonResponse($result);
    }
}
